% Copyright (C) 2017 Christophe Lecomte (University of Southampton)
% This file is part of the PIPER Framework.
% Version: 1.0.0
% 
% The PIPER Framework is free software: you can redistribute it and/or
% modify it under the terms of the GNU General Public License as published
% by the Free Software Foundation, either version 2 of the License, or (at
% your option) any later version.
% 
% The PIPER Framework is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details. You should have received a copy
% of the GNU General Public License along with the PIPER Framework.
% If not, see <http://www.gnu.org/licenses/>.
% 
% Contributors include Christophe Lecomte (University of Southampton)
% 
% This work has received funding from the European Union Seventh Framework
% Program ([FP7/2007-2013]) under grant agreement 605544 [PIPER project]).
% 
function listBP=allSubBP(listBP)
%
% Generate an extended list of Body Parts (BP) that includes all
%       sub body parts (for example, the right femur is added if the input
%       includes the lower limb).
%    also:
%       - Duplicates are suppressed from the list.
%       - any string with commas is splitted into individual strings at the
%         level of the commas.
%
% See Also: includesBP,formattedBP
%
% Christophe Lecomte
% November 2015
% University of Southampton
% EU FP7 project PIPER
%
if ischar(listBP)
    listBP={listBP};
end
%
[listBP,order,~]=unique(listBP);
[~,ind]=sort(order);
listBP=listBP(ind);
%
j=0;
while j<length(listBP)
    BP=listBP{j+1};
    %
    icomma=strfind(BP,',');
    if ~isempty(icomma)
        realBP=BP(1:icomma(1)-1);
        remainingBP=BP(icomma(1)+1:end);
        listBPbefore=listBP(1:j);
        listBPafter=listBP(j+2:end);
        %
        [listBP,order,~]=unique([listBPbefore(:).',...
            {realBP},listBPafter(:).',{remainingBP}]);
        [~,ind]=sort(order);
        listBP=listBP(ind);
    else
        j=j+1;
        %
        if strcmp(BP,'Body_LowerLimb')
            listBP=addBP(listBP,'Body_LowerLimb_R','Body_LowerLimb_L',...
                'Body_Pelvis','Body_Sacrum');
        elseif strcmp(BP,'Body_LowerLimb_R')
            listBP=addBP(listBP,...
                'Body_Hip_R',...
                'Body_Femur_R',...
                'Body_Patella_R',...
                'Body_Tibia_R',...
                'Body_Fibula_R',...
                'Body_Foot_R');
        elseif strcmp(BP,'Body_Foot_R')
            listBP=addBP(listBP,...
                'Body_Calcaneus_R',...
                'Body_Talus_R',...
                'Body_Cuboid_R',...
                'Body_Navicular_R',...
                'Body_Cuneiform1_R',...
                'Body_Cuneiform2_R',...
                'Body_Cuneiform3_R',...
                'Body_Metatarsal1_R',...
                'Body_Metatarsal2_R',...
                'Body_Metatarsal3_R',...
                'Body_Metatarsal4_R',...
                'Body_Metatarsal5_R',...
                'Body_ProximalPhalToe1_R',...
                'Body_ProximalPhalToe2_R',...
                'Body_ProximalPhalToe3_R',...
                'Body_ProximalPhalToe4_R',...
                'Body_ProximalPhalToe5_R',...
                'Body_MiddlePhalToe2_R',...
                'Body_MiddlePhalToe3_R',...
                'Body_MiddlePhalToe4_R',...
                'Body_MiddlePhalToe5_R',...
                'Body_DistalPhalToe1_R',...
                'Body_DistalPhalToe2_R',...
                'Body_DistalPhalToe3_R',...
                'Body_DistalPhalToe4_R',...
                'Body_DistalPhalToe5_R');
        elseif strcmp(BP,'Body_LowerLimb_L')
            listBP=addBP(listBP,...
                'Body_Hip_L',...
                'Body_Femur_L',...
                'Body_Patella_L',...
                'Body_Tibia_L',...
                'Body_Fibula_L',...
                'Body_Foot_L');
        elseif strcmp(BP,'Body_Foot_L')
            listBP=addBP(listBP,...
                'Body_Calcaneus_L',...
                'Body_Talus_L',...
                'Body_Cuboid_L',...
                'Body_Navicular_L',...
                'Body_Cuneiform1_L',...
                'Body_Cuneiform2_L',...
                'Body_Cuneiform3_L',...
                'Body_Metatarsal1_L',...
                'Body_Metatarsal2_L',...
                'Body_Metatarsal3_L',...
                'Body_Metatarsal4_L',...
                'Body_Metatarsal5_L',...
                'Body_ProximalPhalToe1_L',...
                'Body_ProximalPhalToe2_L',...
                'Body_ProximalPhalToe3_L',...
                'Body_ProximalPhalToe4_L',...
                'Body_ProximalPhalToe5_L',...
                'Body_MiddlePhalToe2_L',...
                'Body_MiddlePhalToe3_L',...
                'Body_MiddlePhalToe4_L',...
                'Body_MiddlePhalToe5_L',...
                'Body_DistalPhalToe1_L',...
                'Body_DistalPhalToe2_L',...
                'Body_DistalPhalToe3_L',...
                'Body_DistalPhalToe4_L',...
                'Body_DistalPhalToe5_L');
        elseif strcmp(BP,'Body_Pelvis')
            listBP=addBP(listBP,...
                'Body_Hip_R',...
                'Body_Hip_L',...
                'Body_Sacrum');
        end
    end
end
%
end
%
% =================
%
function listBP=addBP(listBP,varargin)
%

% The three (active) lines of code below achieve the same as the 
%     commented line in Matlab.  The 'stable' option is however not 
%     supported in Octave.
% listBP=unique([listBP(:).',varargin(:).'],'stable');
% =>
    [listBP,order,~]=unique([listBP(:).',varargin(:).']);
    [~,ind]=sort(order);
    listBP=listBP(ind);
%
end
%
% =================









